' *******************************************************************************************************
' *                                                                                                     *
' *     Jazzed_JVM_JemCodes_001.spin                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

CON

  Jem_OPR_NONE          = 0
  Jem_OPR_BYTE          = 1
  Jem_OPR_TWO_BYTES     = 2
  Jem_OPR_WORD          = 2
  Jem_OPR_SIGNED_WORD   = 3
  Jem_OPR_BRANCH        = 3

  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77

CON

  Native_CPU_writeRegister      = $00
  Native_CPU_readRegister       = $01
  Native_CPU_writeObject        = $02
  Native_CPU_delay              = $03
  Native_CPU_message            = $04
  Native_CPU_count              = $06
  Native_CPU_rcTime             = $07
  Native_CPU_pulseIn            = $08
  Native_CPU_pulseOut           = $09
  Native_CPU_readPin            = $0A
  Native_CPU_writePin           = $0B
  Native_CPU_shiftIn            = $0C
  Native_CPU_shiftOut           = $0D
  Native_CPU_carry              = $0E
  Native_CPU_uninstall          = $10
  Native_CPU_install            = $11
  Native_CPU_nap                = $12
  Native_CPU_setOutput          = $13
  Native_CPU_setInput           = $15
  Native_CPU_readSRAM           = $17
  Native_CPU_writeSRAM          = $19
  Native_EEPROM_eeRead          = $1B
  Native_EEPROM_eeWrite         = $1D
  Native_Uart_txInit            = $1F
  Native_Uart_rxInit            = $20
  Native_Uart_rxRead            = $21
  Native_Callback_returnTwo     = $22
  Native_Timer_init             = $23
  Native_Timer_latch            = $24
  Native_PWM_install            = $26
  Native_PWM_updateInternal     = $28
  Native_DAC_install            = $2A
  Native_ADC_install            = $2C
  Native_Terminal_getByte       = $2E

{
PUB NativeMethodNamePtr( nativeMethodNumber )

  case nativeMethodNumber

    Native_CPU_writeRegister:       result := String("CPU_writeRegister")
    Native_CPU_readRegister:        result := String("CPU_readRegister")
    Native_CPU_writeObject:         result := String("CPU_writeObject")
    Native_CPU_delay:               result := String("CPU_delay")
    Native_CPU_message:             result := String("CPU_message")
    Native_CPU_count:               result := String("CPU_count")
    Native_CPU_rcTime:              result := String("CPU_rcTime")
    Native_CPU_pulseIn:             result := String("CPU_pulseIn")
    Native_CPU_pulseOut:            result := String("CPU_pulseOut")
    Native_CPU_readPin:             result := String("CPU_readPin")
    Native_CPU_writePin:            result := String("CPU_writePin")
    Native_CPU_shiftIn:             result := String("CPU_shiftIn")
    Native_CPU_shiftOut:            result := String("CPU_shiftOut")
    Native_CPU_carry:               result := String("CPU_carry")
    Native_CPU_uninstall:           result := String("CPU_uninstall")
    Native_CPU_install:             result := String("CPU_install")
    Native_CPU_nap:                 result := String("CPU_nap")
    Native_CPU_setOutput:           result := String("CPU_setOutput")
    Native_CPU_setInput:            result := String("CPU_setInput")
    Native_CPU_readSRAM:            result := String("CPU_readSRAM")
    Native_CPU_writeSRAM:           result := String("CPU_writeSRAM")
    Native_EEPROM_eeRead:           result := String("EEPROM_eeRead")
    Native_EEPROM_eeWrite:          result := String("EEPROM_eeWrite")
    Native_Uart_txInit:             result := String("Uart_txInit")
    Native_Uart_rxInit:             result := String("Uart_rxInit")
    Native_Uart_rxRead:             result := String("Uart_rxRead")
    Native_Callback_returnTwo:      result := String("Callback_returnTwo")
    Native_Timer_init:              result := String("Timer_init")
    Native_Timer_latch:             result := String("Timer_latch")
    Native_PWM_install:             result := String("PWM_install")
    Native_PWM_updateInternal:      result := String("PWM_updateInternal")
    Native_DAC_install:             result := String("DAC_install")
    Native_ADC_install:             result := String("ADC_install")
    Native_Terminal_getByte:        result := String("Terminal_getByte")
    other:                          result := String("Unknown")
}

CON

  ' Types of array
  
  T_BOOLEAN = 4
  T_CHAR    = 5
  T_FLOAT   = 6
  T_DOUBLE  = 7
  T_BYTE    = 8
  T_SHORT   = 9
  T_INT     = 10
  T_LONG    = 11

  T_ANY     = $7FFF
  T_DELETED = $8000
  
PUB TypeNamePtr( typ )

  case typ & T_ANY
  
    T_BOOLEAN: result := String("BOOLEAN")
    T_CHAR:    result := String("CHAR")
    T_FLOAT:   result := String("FLOAT")
    T_DOUBLE:  result := String("DOUBLE")
    T_BYTE:    result := String("BYTE")
    T_SHORT:   result := String("SHORT")
    T_INT:     result := String("INT")
    T_LONG:    result := String("LONG")
    T_ANY:     result := String("ANY")
    other:     result := String("Unknown")
         

